/*
 *    Copyright 2018-2019 adview.com, Inc.
 *
 *    Licensed under the Apache License, Version 2.0 (the "License");
 *    you may not use this file except in compliance with the License.
 *    You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 *    Unless required by applicable law or agreed to in writing, software
 *    distributed under the License is distributed on an "AS IS" BASIS,
 *    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *    See the License for the specific language governing permissions and
 *    limitations under the License.
 */

package com.adview.mobile.javademo.activities.ads.admob;

import android.os.Bundle;
import android.util.Log;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;

import com.adview.sdk.admob.AdMobMediationInterstitialUtils;
import com.adview.sdk.admob.AdviewInterstitialAdapter;
import com.adview.sdk.api.data.AdUnitFormat;
import com.adview.sdk.api.mediation.MediationInterstitialAdUnit;
import com.adview.mobile.javademo.activities.BaseAdActivity;
import com.google.android.gms.ads.AdRequest;
import com.google.android.gms.ads.LoadAdError;
import com.google.android.gms.ads.interstitial.InterstitialAd;
import com.google.android.gms.ads.interstitial.InterstitialAdLoadCallback;

import java.util.EnumSet;

public class AdMobVideoInterstitialActivity extends BaseAdActivity {

    private static final String AD_UNIT_ID = "ca-app-pub-7283949697136772/5248357557";
    private static final String CONFIG_ID = "POSIDwog9g88wqy1g"; //for video

    private MediationInterstitialAdUnit adUnit;
    private InterstitialAd interstitialAd;

    @Override
    public void onCreate(@Nullable Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        createAd();
    }

    private void createAd() {
        Bundle extras = new Bundle();
        AdRequest request = new AdRequest.Builder()
                .addNetworkExtrasBundle(AdviewInterstitialAdapter.class, extras)
                .build();
        AdMobMediationInterstitialUtils mediationUtils = new AdMobMediationInterstitialUtils(extras);
        adUnit = new MediationInterstitialAdUnit(
                this,
                CONFIG_ID,
                EnumSet.of(AdUnitFormat.VIDEO),
                mediationUtils
        );

        adUnit.fetchDemand(result -> {
            Log.d("Adview", "Fetch demand result: " + result);

            InterstitialAd.load(this, AD_UNIT_ID, request, new InterstitialAdLoadCallback() {
                @Override
                public void onAdLoaded(@NonNull InterstitialAd interstitial) {
                    interstitialAd = interstitial;
                    interstitialAd.show(AdMobVideoInterstitialActivity.this);
                }

                @Override
                public void onAdFailedToLoad(@NonNull LoadAdError error) {
                    interstitialAd = null;
                }
            });
        });
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        if (adUnit != null) {
            adUnit.destroy();
        }
    }
}
